<template>
  <div id="general-Movies-List-wrapper">
    <GenreMenu @selectedGenre="getMoviesByGenreId" @allSelectedGenre="allFilm"/>

<!--    <Search/>-->
    <div class="search">
      <h1>Search</h1>
      <input type="text" v-model="input"/>
    </div>
    <div class="movie-list">
      <div v-for="film in films" :key="film.id">
        <MovieItem :film="film"/>
      </div>
    </div>
    <Pagination
      :page="page?page:1"
      :totalPage="totalPage"
      @goNextPage="pageClick"
      @goPreviousPage="pageClick"
    />
  </div>
</template>

<script>
    import GenreMenu from "../menu/GenreMenu.vue";
    import MovieItem from "./MovieItem.vue";
    import Pagination from "../../components/pagination/Pagination.vue";
    import Search from "../../components/search/Search.vue";
    import store from "@/store";
    import {mapState, mapActions} from 'vuex'

    export default {
        name: "GeneralMoviesList",
        //1)Пейдж и тотал пейдж первести на вуекс(то есть дергать их в компютеде точно также как мы дергаем филмс
        data() {
            return {
                input: ""
            };
        },
        computed: mapState({
            films: state => state.films.films,
            page: state => state.films.carentPage,
            totalPage: state => state.films.pageCount
        }),
        created() {
           this.refreshFilms();
        },
        watch: {
            input: function (val,oldVal) {
                if(val !== '') {
                    this.setAllGenre();
                    store.commit('films/setQuery', val);
                    this.refreshFilms();
                } else {
                    if(oldVal !== '') {
                        store.commit('films/setQuery', '');
                        this.refreshFilms();
                    }
                }

            }
        },
        methods: {
            getMoviesByGenreId(id) {
                this.setZeroQuery();
                store.commit('films/setGenre', id);
                this.refreshFilms();
            },
            allFilm() {
                this.setZeroQuery();
                this.setAllGenre();
                this.refreshFilms();
            },
            pageClick(page) {
                store.commit('films/setCarentPage', page);
                this.refreshFilms();
            },

            refreshFilms() {
                store.dispatch("films/getFilms")
            },

            setAllGenre() {
                store.commit('films/setGenre', null);
                store.commit('genre/setGenre', null);
            },

            setZeroQuery() {
                store.commit('films/setQuery', '');
                this.input = '';
            }


        },
        components: {
            GenreMenu,
            MovieItem,
            Pagination,
            Search
        }
    };
</script>

<style scoped>
  #general-Movies-List-wrapper {
    background: #282c35;
  }

  .movie-list {
    display: grid;
    grid-template-columns: repeat(4, 1fr);
    grid-gap: 10px;
    text-align: center;
  }
</style>
